/*
 * File: DumpDocument.java
 * Creator: George Ferguson
 * Created: Thu Jul  1 14:45:26 2010
 * Time-stamp: <Thu Jul  1 14:45:30 EDT 2010 ferguson>
 */
    protected void dumpDocument() {
	Document doc = pane.getDocument();
	//HTMLDocument hdoc = (HTMLDocument)doc;
	for (Element elt : doc.getRootElements()) {
	    dumpElement(elt, 0);
	}
    }
    protected void indent(int level) {
	for (int i=0; i < level; i++) {
	    System.out.print(" ");
	}
    }
    protected void dumpElement(Element elt, int level) {
	indent(level*2);
	//System.out.print(elt);
	System.out.println(elt.getClass().getSimpleName() + ": ");
	indent(level*2+1);
	System.out.println("start=" + elt.getStartOffset());
	indent(level*2+1);
	System.out.println("end=" + elt.getEndOffset());
	AttributeSet attrs = elt.getAttributes();
	java.util.Enumeration<?> attrNames = attrs.getAttributeNames();
	while (attrNames.hasMoreElements()) {
	    Object attrName = attrNames.nextElement();
	    indent(level*2+1);
	    System.out.println(attrName + "=\"" + attrs.getAttribute(attrName) + "\"");
	}
	try {
	    if (attrs.getAttribute(AttributeSet.NameAttribute) == HTML.Tag.CONTENT) {
		Document doc = elt.getDocument();
		int start = elt.getStartOffset();
		int end = elt.getEndOffset();
		String text = doc.getText(start, end-start);
		indent(level*2+1);
		System.out.println("\"" + text + "\"");
	    }
	} catch (BadLocationException ex) {
	    System.out.println(ex.getMessage());
	}

	// Do children...
	for (int i=0; i < elt.getElementCount(); i++) {
	    dumpElement(elt.getElement(i), level+1);
	}
    }
    protected void processElement(Element elt, int level) {
	for (int i=0; i < level; i++) {
	    System.out.print(" ");
	}
	System.out.print(elt);
	for (int i=0; i < elt.getElementCount(); i++) {
	    dumpElement(elt.getElement(i), level+1);
	}
    }

